diff -pru mailman-cvs-HEAD/Mailman/MailList.py mailman-2.1.7.cg/Mailman/MailList.py
--- mailman-cvs-HEAD/Mailman/MailList.py	2006-03-12 17:05:37.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/MailList.py	2006-03-09 10:24:43.000000000 +0100
@@ -1,4 +1,4 @@
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998-2005 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -186,8 +186,8 @@ class MailList(HTMLFormatter, Deliverer,
 
     def getListAddress(self, extra=None):
         if extra is None:
-            return '%s@%s' % (self.internal_name(), self.host_name)
-        return '%s-%s@%s' % (self.internal_name(), extra, self.host_name)
+            return '%s@%s' % (self.local_part, self.host_name)
+        return '%s-%s@%s' % (self.local_part, extra, self.host_name)
 
     # For backwards compatibility
     def GetBouncesEmail(self):
@@ -204,14 +204,13 @@ class MailList(HTMLFormatter, Deliverer,
 
     def GetConfirmEmail(self, cookie):
         return mm_cfg.VERP_CONFIRM_FORMAT % {
-            'addr'  : '%s-confirm' % self.internal_name(),
+            'addr'  : '%s-confirm' % self.local_part,
             'cookie': cookie,
             } + '@' + self.host_name
 
     def GetConfirmJoinSubject(self, listname, cookie):
         if mm_cfg.VERP_CONFIRMATIONS and cookie:
-            cset = i18n.get_translation().charset() or \
-                       Utils.GetCharSet(self.preferred_language)
+            cset = Utils.GetCharSet(self.preferred_language)
             subj = Header(
      _('Your confirmation is required to join the %(listname)s mailing list'),
                           cset, header_name='subject')
@@ -221,8 +220,7 @@ class MailList(HTMLFormatter, Deliverer,
 
     def GetConfirmLeaveSubject(self, listname, cookie):
         if mm_cfg.VERP_CONFIRMATIONS and cookie:
-            cset = i18n.get_translation().charset() or \
-                       Utils.GetCharSet(self.preferred_language)
+            cset = Utils.GetCharSet(self.preferred_language)
             subj = Header(
      _('Your confirmation is required to leave the %(listname)s mailing list'),
                           cset, header_name='subject')
@@ -250,8 +248,10 @@ class MailList(HTMLFormatter, Deliverer,
             return "%s%s@%s" % (acct, self.umbrella_member_suffix, host)
 
     def GetScriptURL(self, scriptname, absolute=0):
+        # Using "local_part" here works for both site wide lists on
+        # the default url host and for vhost lists on the vhost url host.
         return Utils.ScriptURL(scriptname, self.web_page_url, absolute) + \
-               '/' + self.internal_name()
+               '/' + self.local_part
 
     def GetOptionsURL(self, user, obscure=0, absolute=0):
         url = self.GetScriptURL('options', absolute)
@@ -295,6 +295,10 @@ class MailList(HTMLFormatter, Deliverer,
         # Non-configurable list info
         if name:
           self._internal_name = name
+        if '@' in self._internal_name:
+            self.local_part = self._internal_name.split('@')[0]
+        else:
+            self.local_part = self._internal_name
 
         # When was the list created?
         self.created_at = time.time()
@@ -344,8 +348,7 @@ class MailList(HTMLFormatter, Deliverer,
                 mm_cfg.DEFAULT_BOUNCE_MATCHING_HEADERS
         self.header_filter_rules = []
         self.anonymous_list = mm_cfg.DEFAULT_ANONYMOUS_LIST
-        internalname = self.internal_name()
-        self.real_name = internalname[0].upper() + internalname[1:]
+        self.real_name = self.local_part[0].upper() + self.local_part[1:]
         self.description = ''
         self.info = ''
         self.welcome_msg = ''
@@ -479,7 +482,13 @@ class MailList(HTMLFormatter, Deliverer,
         # the admin's email address, so transform the exception.
         if emailhost is None:
             emailhost = mm_cfg.DEFAULT_EMAIL_HOST
-        postingaddr = '%s@%s' % (name, emailhost)
+        if '@' in name:
+            firstname, emailhost = name.split('@', 1)
+        else:
+            firstname = name
+
+        # but we keep a sensible posting address
+        postingaddr = '%s@%s' % (firstname, emailhost)
         try:
             Utils.ValidateEmail(postingaddr)
         except Errors.MMBadEmailError:
@@ -487,11 +496,16 @@ class MailList(HTMLFormatter, Deliverer,
         # Validate the admin's email address
         Utils.ValidateEmail(admin)
         self._internal_name = name
+
         self._full_path = Site.get_listpath(name, create=1)
         # Don't use Lock() since that tries to load the non-existant config.pck
         self.__lock.lock()
         self.InitVars(name, admin, crypted_password)
         self.CheckValues()
+        # this is for getListAddress
+        self.list_address = postingaddr
+        self.real_name = firstname
+        self.subject_prefix = mm_cfg.DEFAULT_SUBJECT_PREFIX % self.__dict__
         if langs is None:
             self.available_languages = [self.preferred_language]
         else:
@@ -754,6 +768,15 @@ class MailList(HTMLFormatter, Deliverer,
             else:
                 goodtopics.append((name, pattern, desc, emptyflag))
         self.topics = goodtopics
+        # Define local_part if not defined yet (loaded ML in old data format).
+        if self.__dict__.has_key('local_part') and self.local_part:
+            pass
+        else:
+            _tmp = self.internal_name()
+            if '@' in _tmp:
+                self.local_part = _tmp.split('@')[0]
+            else:
+                self.local_part = _tmp
 
 
     #
@@ -969,7 +992,7 @@ class MailList(HTMLFormatter, Deliverer,
         else:
             kind = ''
         syslog('subscribe', '%s: new%s %s, %s', self.internal_name(),
-               kind, formataddr((name, email)), whence)
+               kind, formataddr((email, name)), whence)
         if ack:
             self.SendSubscribeAck(email, self.getMemberPassword(email),
                                   digest, text)
@@ -1125,7 +1148,6 @@ class MailList(HTMLFormatter, Deliverer,
             self.removeMember(oldaddr)
         else:
             self.changeMemberAddress(oldaddr, newaddr)
-            self.log_and_notify_admin(oldaddr, newaddr)
         # If globally is true, then we also include every list for which
         # oldaddr is a member.
         if not globally:
@@ -1149,39 +1171,10 @@ class MailList(HTMLFormatter, Deliverer,
                     mlist.removeMember(oldaddr)
                 else:
                     mlist.changeMemberAddress(oldaddr, newaddr)
-                    mlist.log_and_notify_admin(oldaddr, newaddr)
                 mlist.Save()
             finally:
                 mlist.Unlock()
 
-    def log_and_notify_admin(self, oldaddr, newaddr):
-        """Log member address change and notify admin if requested."""
-        syslog('subscribe', '%s: changed member address from %s to %s',
-               self.internal_name(), oldaddr, newaddr)
-        if self.admin_notify_mchanges:
-            lang = self.preferred_language
-            otrans = i18n.get_translation()
-            i18n.set_language(lang)
-            try:
-                realname = self.real_name
-                subject = _('%(realname)s address change notification')
-            finally:
-                i18n.set_translation(otrans)
-            name = self.getMemberName(newaddr)
-            if name is None:
-                name = ''
-            if isinstance(name, UnicodeType):
-                name = name.encode(Utils.GetCharSet(lang), 'replace')
-            text = Utils.maketext(
-                'adminaddrchgack.txt',
-                {'name'    : name,
-                 'oldaddr' : oldaddr,
-                 'newaddr' : newaddr,
-                 'listname': self.real_name,
-                 }, mlist=self)
-            msg = Message.OwnerNotification(self, subject, text)
-            msg.send(self)
-
 
     #
     # Confirmation processing
@@ -1352,7 +1345,7 @@ class MailList(HTMLFormatter, Deliverer,
         addresses in the recipient headers.
         """
         # This is the list's full address.
-        listfullname = '%s@%s' % (self.internal_name(), self.host_name)
+        listfullname = self.getListAddress()
         recips = []
         # Check all recipient addresses against the list's explicit addresses,
         # specifically To: Cc: and Resent-to:
@@ -1367,7 +1360,7 @@ class MailList(HTMLFormatter, Deliverer,
             addr = addr.lower()
             localpart = addr.split('@')[0]
             if (# TBD: backwards compatibility: deprecated
-                    localpart == self.internal_name() or
+                    localpart == self.local_part or
                     # exact match against the complete list address
                     addr == listfullname):
                 return True
diff -pru mailman-cvs-HEAD/Mailman/Message.py mailman-2.1.7.cg/Mailman/Message.py
--- mailman-cvs-HEAD/Mailman/Message.py	2006-03-10 11:36:00.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Message.py	2005-12-30 19:50:07.000000000 +0100
@@ -1,4 +1,4 @@
-# Copyright (C) 1998-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 1998-2005 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
diff -pru mailman-cvs-HEAD/Mailman/MTA/Manual.py mailman-2.1.7.cg/Mailman/MTA/Manual.py
--- mailman-cvs-HEAD/Mailman/MTA/Manual.py	2005-12-30 19:56:46.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/MTA/Manual.py	2006-03-09 10:29:20.000000000 +0100
@@ -1,4 +1,4 @@
-# Copyright (C) 2001-2003 by the Free Software Foundation, Inc.
+# Copyright (C) 2001-2005 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -56,6 +56,7 @@ def create(mlist, cgi=False, nolock=Fals
     if mlist is None:
         return
     listname = mlist.internal_name()
+    assert('@' not in listname) # No Manual MTA support for vhost lists
     fieldsz = len(listname) + len('-unsubscribe')
     if cgi:
         # If a list is being created via the CGI, the best we can do is send
@@ -104,6 +105,7 @@ equivalent) file by adding the following
 
 def remove(mlist, cgi=False):
     listname = mlist.internal_name()
+    assert('@' not in listname) # No Manual MTA support for vhost lists
     fieldsz = len(listname) + len('-unsubscribe')
     if cgi:
         # If a list is being removed via the CGI, the best we can do is send
diff -pru mailman-cvs-HEAD/Mailman/MTA/Postfix.py mailman-2.1.7.cg/Mailman/MTA/Postfix.py
--- mailman-cvs-HEAD/Mailman/MTA/Postfix.py	2005-12-30 19:56:46.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/MTA/Postfix.py	2006-03-04 18:13:08.000000000 +0100
@@ -28,12 +28,13 @@ from Mailman import mm_cfg
 from Mailman import Utils
 from Mailman import LockFile
 from Mailman.i18n import _
-from Mailman.MTA.Utils import makealiases
+from Mailman.MTA.Utils import makealiases, _extensions
 from Mailman.Logging.Syslog import syslog
 
 LOCKFILE = os.path.join(mm_cfg.LOCK_DIR, 'creator')
 ALIASFILE = os.path.join(mm_cfg.DATA_DIR, 'aliases')
 VIRTFILE = os.path.join(mm_cfg.DATA_DIR, 'virtual-mailman')
+TRANSPORTFILE = os.path.join(mm_cfg.DATA_DIR, 'transport-mailman')
 
 try:
     True, False
@@ -43,21 +44,23 @@ except NameError:
 
 
 
-def _update_maps():
-    msg = 'command failed: %s (status: %s, %s)'
-    acmd = mm_cfg.POSTFIX_ALIAS_CMD + ' ' + ALIASFILE
-    status = (os.system(acmd) >> 8) & 0xff
+def _update_map_file(mapfile, command=mm_cfg.POSTFIX_MAP_CMD):
+    msg = 'command failed: %s (status: %s, %s)'        
+    cmdline = command + ' ' + mapfile
+    status = os.spawnlp(os.P_WAIT, command, command, mapfile)
     if status:
         errstr = os.strerror(status)
-        syslog('error', msg, acmd, status, errstr)
-        raise RuntimeError, msg % (acmd, status, errstr)
+        syslog('error', msg, cmdline, status, errstr)
+        raise RuntimeError, msg % (cmdline, status, errstr)
+
+
+
+def _update_maps():
+    _update_map_file(ALIASFILE, command = mm_cfg.POSTFIX_ALIAS_CMD)
     if os.path.exists(VIRTFILE):
-        vcmd = mm_cfg.POSTFIX_MAP_CMD + ' ' + VIRTFILE
-        status = (os.system(vcmd) >> 8) & 0xff
-        if status:
-            errstr = os.strerror(status)
-            syslog('error', msg, vcmd, status, errstr)
-            raise RuntimeError, msg % (vcmd, status, errstr)
+        _update_map_file(VIRTFILE)
+    if os.path.exists(TRANSPORTFILE):
+        _update_map_file(TRANSPORTFILE)
 
 
 
@@ -79,7 +82,31 @@ def clear():
 
 
 
-def _addlist(mlist, fp):
+def _generate_alias(mlist, ext=None):
+    listname = mlist.internal_name()
+    if '@' in listname:
+        foo = listname.split('@')
+        foo.reverse()
+        aliaslistname = '='.join(foo)
+    else:
+        aliaslistname = listname
+    if ext:
+        return aliaslistname + '-' + ext
+    else:
+        return aliaslistname
+
+
+def _uses_transport(mlist):
+    listname = mlist.internal_name()
+    if False: # XXX mm_cfg.VHOST_USES_TRANSPORTS ... TBD NDIM
+        return ('@' in listname) and (mlist.host_name not in
+                                      mm_cfg.POSTFIX_STYLE_VIRTUAL_DOMAINS)
+    else:
+        return False
+
+
+
+def _addalias(mlist, fp):
     # Set up the mailman-loop address
     loopaddr = Utils.ParseEmail(Utils.get_site_email(extra='loop'))[0]
     loopmbox = os.path.join(mm_cfg.DATA_DIR, 'owner-bounces.mbox')
@@ -101,13 +128,18 @@ def _addlist(mlist, fp):
     # exercise is to get the minimal aliases.db file into existance.
     if mlist is None:
         return
+    # Only generate aliases for site wide lists and for lists in
+    # mm_cfg.POSTFIX_STYLE_VIRTUAL_DOMAINS
+    if _uses_transport(mlist):
+        return
     listname = mlist.internal_name()
-    fieldsz = len(listname) + len('-unsubscribe')
     # The text file entries get a little extra info
     print >> fp, '# STANZA START:', listname
     print >> fp, '# CREATED:', time.ctime(time.time())
     # Now add all the standard alias entries
-    for k, v in makealiases(listname):
+    fieldsz = len('-unsubscribe')
+    for k, v in makealiases(_generate_alias(mlist),
+                            internal_listname = listname):
         # Format the text file nicely
         print >> fp, k + ':', ((fieldsz - len(k)) * ' ') + v
     # Finish the text file stanza
@@ -118,8 +150,6 @@ def _addlist(mlist, fp):
 
 def _addvirtual(mlist, fp):
     listname = mlist.internal_name()
-    fieldsz = len(listname) + len('-unsubscribe')
-    hostname = mlist.host_name
     # Set up the mailman-loop address
     loopaddr = Utils.get_site_email(mlist.host_name, extra='loop')
     loopdest = Utils.ParseEmail(loopaddr)[0]
@@ -140,14 +170,26 @@ def _addvirtual(mlist, fp):
 %s\t%s
 # LOOP ADDRESSES END
 """ % (loopaddr, loopdest)
+    # NDIM XXX What are those loop addrs for, and do we need them for each
+    # virtual domain?
+    
+    # Only generate virtual alias for lists in
+    # NDIM DBG print "_addvirtual", listname
+    if '@' not in listname or _uses_transport(mlist):
+        return
     # The text file entries get a little extra info
     print >> fp, '# STANZA START:', listname
     print >> fp, '# CREATED:', time.ctime(time.time())
     # Now add all the standard alias entries
-    for k, v in makealiases(listname):
-        fqdnaddr = '%s@%s' % (k, hostname)
+    addrs = [ (mlist.getListAddress(),
+               _generate_alias(mlist)) ] # XXX name space clash
+    for ext in _extensions:
+        addrs.append((mlist.getListAddress(ext),
+                      _generate_alias(mlist, ext=ext))) # XXX name space clash
+    fieldsz = len(mlist.getListAddress('-unsubscribe'))
+    for addr, target in addrs:
         # Format the text file nicely
-        print >> fp, fqdnaddr, ((fieldsz - len(k)) * ' '), k
+        print >> fp, addr, ((fieldsz - len(addr)) * ' '), target
     # Finish the text file stanza
     print >> fp, '# STANZA END:', listname
     print >> fp
@@ -198,6 +240,42 @@ def _check_for_virtual_loopaddr(mlist, f
 
 
 
+def _addtransport(mlist, fp):
+    # XXX Set up the mailman-loop address
+    #loopaddr = Utils.get_site_email(mlist.host_name, extra='loop')
+    #loopdest = Utils.ParseEmail(loopaddr)[0]
+    # Seek to the end of the text file, but if it's empty write the standard
+    # disclaimer, and the loop catch address.
+    fp.seek(0, 2)
+    if not fp.tell():
+        print >> fp, """\
+# This file is generated by Mailman, and is kept in sync with the binary hash
+# file transport-mailman.db.  YOU SHOULD NOT MANUALLY EDIT THIS FILE unless you
+# know what you're doing, and can keep the two files properly in sync.  If you
+# screw it up, you're on your own.
+
+"""
+    # Only generate transport for vhost list
+    if not _uses_transport(mlist):
+        return
+    # The text file entries get a little extra info
+    print >> fp, '# STANZA START:', listname
+    print >> fp, '# CREATED:', time.ctime(time.time())
+    # Now add all the standard alias entries
+    listname = mlist.internal_name()
+    fieldsz = len('-unsubscribe')
+    addrs = [ mlist.getListAddress() ]
+    for ext in _extensions:
+        addrs.append(mlist.getListAddress(ext))
+    for addr in addrs:
+        target = "mailman:"
+        print >> fp, addr, ((fieldsz - len(ext)) * ' '), target
+    # Finish the text file stanza
+    print >> fp, '# STANZA END:', listname
+    print >> fp
+
+
+
 def _do_create(mlist, textfile, func):
     # Crack open the plain text file
     try:
@@ -213,6 +291,8 @@ def _do_create(mlist, textfile, func):
         func(mlist, fp)
     finally:
         fp.close()
+
+    # XXX check transports?
     # Now double check the virtual plain text file
     if func is _addvirtual:
         _check_for_virtual_loopaddr(mlist, textfile)
@@ -226,9 +306,10 @@ def create(mlist, cgi=False, nolock=Fals
         lock.lock()
     # Do the aliases file, which need to be done in any case
     try:
-        _do_create(mlist, ALIASFILE, _addlist)
-        if mlist and mlist.host_name in mm_cfg.POSTFIX_STYLE_VIRTUAL_DOMAINS:
+        _do_create(mlist, ALIASFILE, _addalias)
+        if mlist and '@' in mlist.internal_name(): # NDIM XXX and mlist.host_name in mm_cfg.POSTFIX_STYLE_VIRTUAL_DOMAINS:
             _do_create(mlist, VIRTFILE, _addvirtual)
+        _do_create(mlist, TRANSPORTFILE, _addtransport)
         _update_maps()
     finally:
         if lock:
diff -pru mailman-cvs-HEAD/Mailman/MTA/Utils.py mailman-2.1.7.cg/Mailman/MTA/Utils.py
--- mailman-cvs-HEAD/Mailman/MTA/Utils.py	2005-08-27 03:54:02.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/MTA/Utils.py	2006-02-22 12:26:47.000000000 +0100
@@ -22,6 +22,10 @@ import pwd
 from Mailman import mm_cfg
 
 
+_extensions = ('admin', 'bounces', 'confirm', 'join', 'leave', 'owner',
+               'request', 'subscribe', 'unsubscribe', )
+
+
 
 def getusername():
     username = os.environ.get('USER') or os.environ.get('LOGNAME')
@@ -34,7 +38,9 @@ def getusername():
 
 
 
-def _makealiases_mailprog(listname):
+def _makealiases_mailprog(listname, internal_listname=None):
+    if not internal_listname:
+        internal_listname = listname
     wrapper = os.path.join(mm_cfg.WRAPPER_DIR, 'mailman')
     # Most of the list alias extensions are quite regular.  I.e. if the
     # message is delivered to listname-foobar, it will be filtered to a
@@ -46,12 +52,11 @@ def _makealiases_mailprog(listname):
     #    need for the -admin address anymore).
     #
     # Seed this with the special cases.
-    aliases = [(listname,          '"|%s post %s"' % (wrapper, listname)),
+    aliases = [(listname,          '"|%s post %s"' % (wrapper, internal_listname)),
                ]
-    for ext in ('admin', 'bounces', 'confirm', 'join', 'leave', 'owner',
-                'request', 'subscribe', 'unsubscribe'):
+    for ext in _extensions:
         aliases.append(('%s-%s' % (listname, ext),
-                        '"|%s %s %s"' % (wrapper, ext, listname)))
+                        '"|%s %s %s"' % (wrapper, ext, internal_listname)))
     return aliases
 
 
@@ -66,8 +71,7 @@ def _makealiases_maildir(listname):
     # Note, don't use this unless your MTA leaves the envelope recipient in
     # Delivered-To:, Envelope-To:, or Apparently-To:
     aliases = [(listname, maildir)]
-    for ext in ('admin', 'bounces', 'confirm', 'join', 'leave', 'owner',
-                'request', 'subscribe', 'unsubscribe'):
+    for ext in _extensions:
         aliases.append(('%s-%s' % (listname, ext), maildir))
     return aliases
 
diff -pru mailman-cvs-HEAD/Mailman/Queue/ArchRunner.py mailman-2.1.7.cg/Mailman/Queue/ArchRunner.py
--- mailman-cvs-HEAD/Mailman/Queue/ArchRunner.py	2006-02-03 09:12:14.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Queue/ArchRunner.py	2005-08-27 03:40:16.000000000 +0200
@@ -49,7 +49,7 @@ class ArchRunner(Runner):
                 elif abs(now - mktime_tz(tup)) > \
                          mm_cfg.ARCHIVER_ALLOWABLE_SANE_DATE_SKEW:
                     clobber = 1
-            except (ValueError, OverflowError):
+            except ValueError:
                 # The likely cause of this is that the year in the Date: field
                 # is horribly incorrect, e.g. (from SF bug # 571634):
                 # Date: Tue, 18 Jun 0102 05:12:09 +0500
diff -pru mailman-cvs-HEAD/Mailman/Queue/BounceRunner.py mailman-2.1.7.cg/Mailman/Queue/BounceRunner.py
--- mailman-cvs-HEAD/Mailman/Queue/BounceRunner.py	2006-03-10 11:36:01.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Queue/BounceRunner.py	2006-03-09 19:49:12.000000000 +0100
@@ -1,4 +1,4 @@
-# Copyright (C) 2001-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 2001-2004 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -12,8 +12,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 """Bounce queue runner."""
 
@@ -89,12 +88,9 @@ class BounceMixin:
     def _queue_bounces(self, listname, addrs, msg):
         today = time.localtime()[:3]
         if self._bounce_events_fp is None:
-            omask = os.umask(006)
-            try:
-                self._bounce_events_fp = open(self._bounce_events_file, 'a+b')
-            finally:
-                os.umask(omask)
+            self._bounce_events_fp = open(self._bounce_events_file, 'a+b')
         for addr in addrs:
+            # NDIM XXX: Where is this "listname" (aka internal_name()) read?
             cPickle.dump((listname, addr, today, msg),
                          self._bounce_events_fp, 1)
         self._bounce_events_fp.flush()
@@ -197,11 +193,7 @@ class BounceRunner(Runner, BounceMixin):
             return
         # Try VERP detection first, since it's quick and easy
         addrs = verp_bounce(mlist, msg)
-        if addrs:
-            # We have an address, but check if the message is non-fatal.
-            if BouncerAPI.ScanMessages(mlist, msg) is BouncerAPI.Stop:
-                return
-        else:
+        if not addrs:
             # See if this was a probe message.
             token = verp_probe(mlist, msg)
             if token:
@@ -210,9 +202,6 @@ class BounceRunner(Runner, BounceMixin):
             # That didn't give us anything useful, so try the old fashion
             # bounce matching modules.
             addrs = BouncerAPI.ScanMessages(mlist, msg)
-            if addrs is BouncerAPI.Stop:
-                # This is a recognized, non-fatal notice. Ignore it.
-                return
         # If that still didn't return us any useful addresses, then send it on
         # or discard it.
         if not addrs:
diff -pru mailman-cvs-HEAD/Mailman/Queue/NewsRunner.py mailman-2.1.7.cg/Mailman/Queue/NewsRunner.py
--- mailman-cvs-HEAD/Mailman/Queue/NewsRunner.py	2005-08-28 07:31:27.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Queue/NewsRunner.py	2006-03-09 19:44:04.000000000 +0100
@@ -38,7 +38,7 @@ mcre = re.compile(r"""
     \d+.                                          # serial number
     \d+.                                          # time in seconds since epoch
     \d+.                                          # pid
-    (?P<listname>[^@]+)                           # list's internal_name()
+    (?P<localpart>[^@]+)                          # list's local_part
     @                                             # localpart@dom.ain
     (?P<hostname>[^>]+)                           # list's host_name
     >                                             # trailer
@@ -139,8 +139,10 @@ def prepare_message(mlist, msg, msgdata)
     if msgid:
         mo = mcre.search(msgid)
         if mo:
-            lname, hname = mo.group('listname', 'hostname')
-            if lname == mlist.internal_name() and hname == mlist.host_name:
+            lname, hname = mo.group('localname', 'hostname')
+            if '@'.join(lname, hname) == mlist.internal_name():
+                hackmsgid = False
+            elif lname == mlist.internal_name() and hname == mlist.host_name:
                 hackmsgid = False
     if hackmsgid:
         del msg['message-id']
diff -pru mailman-cvs-HEAD/Mailman/SecurityManager.py mailman-2.1.7.cg/Mailman/SecurityManager.py
--- mailman-cvs-HEAD/Mailman/SecurityManager.py	2005-08-28 07:31:26.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/SecurityManager.py	2006-03-04 12:27:50.000000000 +0100
@@ -86,6 +86,9 @@ class SecurityManager:
         # Non configurable
         self.passwords = {}
 
+    def _cookie_key(self):
+        return self.internal_name().replace('@','%40')
+
     def AuthContextInfo(self, authcontext, user=None):
         # authcontext may be one of AuthUser, AuthListModerator,
         # AuthListAdmin, AuthSiteAdmin.  Not supported is the AuthCreator
@@ -98,7 +101,8 @@ class SecurityManager:
         # AuthUser, but the user isn't a member of this mailing list, a
         # NotAMemberError will be raised.  If the user's secret is None, raise
         # a MMBadUserError.
-        key = self.internal_name() + '+'
+        # NDIM: XXX Does this have security implications?
+        key = self._cookie_key() + '+' 
         if authcontext == mm_cfg.AuthUser:
             if user is None:
                 # A bad system error
@@ -292,7 +296,7 @@ class SecurityManager:
                 usernames = [user]
             else:
                 usernames = []
-                prefix = self.internal_name() + '+user+'
+                prefix = self._cookie_key() + '+user+'
                 for k in c.keys():
                     if k.startswith(prefix):
                         usernames.append(k[len(prefix):])
